ArrayList<Polygon> mypg;

//Serial myPort;
PrintWriter output;

public void setup() {
  size(300,300);

  output = createWriter("g.ngc");
  //--------------------------------------------------------------------------------------------------
}

void draw() {
  gcode();
  exit();
}

class Polygon{
  public ArrayList<PVector> mypoint;
  PVector ppp;
  public String myname;
  Polygon(String x){
    //println(x);
     mypoint=new ArrayList();
     String[] p = splitTokens(x,":");
     for (int i = 0; i < p.length; i++) { 
         String[] pp=splitTokens(p[i],",");
         //println(pp[0] +":" +pp[1]);
         ppp=new  PVector(float(pp[0]),float(pp[1]));
         mypoint.add(ppp);
     }
  }
}


void gcode(){
  String lines[];
  boolean pflag=false;
  String sd;
  Polygon myp;
 

  mypg=new ArrayList();
  //--------------------------
  
  
  lines = loadStrings("a.svg");
  sd="";
  for (int i = 0; i < lines.length; i++) { 
      try{
          String[] m1 = match(lines[i], "polygon");
          String[] m2 = match(lines[i], "</g>");
          if(m1!= null && pflag==false) {
            pflag=true;
          }
          if(m2!= null && pflag) {
            pflag=false;
          }
          if(pflag){
              //polygonデータを分割する
              String[] s = splitTokens(lines[i]);
              for(int j=0; j<s.length; j++){

                 s[j]=s[j].replaceAll("points=\"","");
                 String[] m3 = match(s[j], "polygon");
                 String[] m4 = match(s[j], "/>");
                 String[] m5 = match(s[j], "\"");
                 if(m4!=null){
                   myp=new Polygon(sd);
                   mypg.add(myp);
                   sd="";
                 }
                 
                 if(m3== null && m4== null && m5== null) {
                   sd=sd+":" +s[j];
                 }
              } 
          }
      }catch(StringIndexOutOfBoundsException e){
      }catch(NullPointerException e){
      }
  }
  //最大値----------------------------------------------------------------------------------------------
  float maxv=0;
  for (int i = 0; i < mypg.size(); i++) { 
      Polygon op=mypg.get(i);
        for (int j = 1; j < op.mypoint.size(); j++) { 
          if (maxv<op.mypoint.get(j).x){
            maxv=op.mypoint.get(j-1).x;
          }
          if (maxv<op.mypoint.get(j).y){
            maxv=op.mypoint.get(j-1).y;
          }
        }
  }
//--------------------------------------------------------------------------------------------------  
  output.print("T2 S1\n");
  output.flush();
   for (int i = 0; i < mypg.size(); i++) { 
      Polygon op=mypg.get(i);
        for (int j = 0; j < op.mypoint.size(); j++) { 
          int cvx=round(op.mypoint.get(j).x * 20/maxv);
          int cvy=round(op.mypoint.get(j).y * 20/maxv+10);
          
          if (j==0){
             output.print("G00 X"+cvx+" Y"+cvy+"\n");
             output.flush();
          }        
          output.print("G01 X"+cvx+" Y"+cvy+"\n");
          output.flush();       
          if (j==op.mypoint.size()-1){
            output.print("G00 X"+cvx+" Y"+cvy+"\n");
            output.flush();
          }
          //delay(500);
        }  
  }
  output.print("G00 X0 Y0 \n");
  output.flush();
  output.print("T2 S1\n");
  output.flush();
}